﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;
using System.Net;
using System.Net.Sockets;
using System.IO;
using System.Management;
using System.Threading;
namespace dSexample
{
    public partial class Form1 : Form
    {
        TcpClient clientSocket = new TcpClient();

        struct UdpState
        {
            public System.Net.IPEndPoint EP;
            public System.Net.Sockets.UdpClient UDPClient;
        }
        private UdpState GlobalUDP;
        byte DS1242_MODULEID = 31;

        public Form1()
        {
            InitializeComponent();
            comboBox_IP.Items.Add("Custom IP");
            comboBox_IP.Sorted = true;
            try
            {
                GlobalUDP.UDPClient = new UdpClient();
                GlobalUDP.EP = new System.Net.IPEndPoint(System.Net.IPAddress.Parse("255.255.255.255"), 30303);
                System.Net.IPEndPoint BindEP = new System.Net.IPEndPoint(System.Net.IPAddress.Any, 30303);
                byte[] DiscoverMsg = Encoding.ASCII.GetBytes("Discovery: Who is out there?");

                // Set the local UDP port to listen on
                GlobalUDP.UDPClient.Client.Bind(BindEP);

                // Enable the transmission of broadcast packets without having them be received by ourself
                GlobalUDP.UDPClient.EnableBroadcast = true;
                GlobalUDP.UDPClient.MulticastLoopback = false;

                // Configure ourself to receive discovery responses
                GlobalUDP.UDPClient.BeginReceive(ReceiveCallback, GlobalUDP);

                // Transmit the discovery request message
                GlobalUDP.UDPClient.Send(DiscoverMsg, DiscoverMsg.Length, new System.Net.IPEndPoint(System.Net.IPAddress.Parse("255.255.255.255"), 30303));
            }
            catch { }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {

            byte[] stream = new byte[16];
            stream[0] = 0x33;
            stream[1] = 1;

            writeData(stream, 2);                           // Write data to module
            Array.Copy(readData(5), 0, stream, 0, 5);        // Read data back from module and copy it into stream array

            if ((stream[4] & 0x0001) == 0) button1.BackColor = Color.WhiteSmoke;
            else button1.BackColor = Color.MistyRose;
            if ((stream[4] & 0x0002) == 0) button2.BackColor = Color.WhiteSmoke;
            else button2.BackColor = Color.MistyRose;

            stream[0] = 0x34;        // change command to get inputs, request input1, but we will use the full packed inputs bytes that follow in position 1
	        stream[1] = 1;
            writeData(stream, 2);
            Array.Copy(readData(2), 0, stream, 0, 2);

            if ((stream[1] & 0x0001) == 0) IO1.Checked = false; else IO1.Checked = true;
            if ((stream[1] & 0x0002) == 0) IO2.Checked = false; else IO2.Checked = true;
            if ((stream[1] & 0x0004) == 0) IO3.Checked = false; else IO3.Checked = true;
            if ((stream[1] & 0x0008) == 0) IO4.Checked = false; else IO4.Checked = true;

            stream[0] = 0x35;       // read analog inputs
            writeData(stream, 2);
            Array.Copy(readData(4), 0, stream, 0, 4);

            int x = (stream[0] << 8) + (stream[1]);
            adc1.Text = string.Format("{0}", x);
            x = (stream[2] << 8) + (stream[3]);
            adc2.Text = string.Format("{0}", x);

            stream[0] = 0x36;   // Get Timer/ Counter 1
            stream[1] = 0x01;
            writeData(stream, 2);
            Array.Copy(readData(8), 0, stream, 0, 8);
            labelCounter1.Text = string.Format("Counter 1 : {0}", ((stream[0] << 24) | (stream[1] << 16) | (stream[2] << 8) | stream[3]));
            labelCapture1.Text = string.Format("Capture 1 : {0}", ((stream[4] << 24) | (stream[5] << 16) | (stream[6] << 8) | stream[7]));

            stream[0] = 0x36;
            stream[1] = 0x02;
            writeData(stream, 2);
            Array.Copy(readData(8), 0, stream, 0, 8);
            labelCounter2.Text = string.Format("Counter 2 : {0}", ((stream[0] << 24) | (stream[1] << 16) | (stream[2] << 8) | stream[3]));
            labelCapture2.Text = string.Format("Capture 2 : {0}", ((stream[4] << 24) | (stream[5] << 16) | (stream[6] << 8) | stream[7]));

            stream[0] = 0x36;
            stream[1] = 0x03;
            writeData(stream, 2);
            Array.Copy(readData(8), 0, stream, 0, 8);
            labelCounter3.Text = string.Format("Counter 3 : {0}", ((stream[0] << 24) | (stream[1] << 16) | (stream[2] << 8) | stream[3]));
            labelCapture3.Text = string.Format("Capture 3 : {0}", ((stream[4] << 24) | (stream[5] << 16) | (stream[6] << 8) | stream[7]));

            stream[0] = 0x36;
            stream[1] = 0x04;
            writeData(stream, 2);
            Array.Copy(readData(8), 0, stream, 0, 8);
            labelCounter4.Text = string.Format("Counter 4 : {0}", ((stream[0] << 24) | (stream[1] << 16) | (stream[2] << 8) | stream[3]));
            labelCapture4.Text = string.Format("Capture 4 : {0}", ((stream[4] << 24) | (stream[5] << 16) | (stream[6] << 8) | stream[7]));

            stream[0] = 0x36;
            stream[1] = 0x05;
            writeData(stream, 2);
            Array.Copy(readData(8), 0, stream, 0, 8);
            labelCounter5.Text = string.Format("Counter 5 : {0}", ((stream[0] << 24) | (stream[1] << 16) | (stream[2] << 8) | stream[3]));
            labelCapture5.Text = string.Format("Capture 5 : {0}", ((stream[4] << 24) | (stream[5] << 16) | (stream[6] << 8) | stream[7]));

            stream[0] = 0x36;
            stream[1] = 0x06;
            writeData(stream, 2);
            Array.Copy(readData(8), 0, stream, 0, 8);
            labelCounter6.Text = string.Format("Counter 6 : {0}", ((stream[0] << 24) | (stream[1] << 16) | (stream[2] << 8) | stream[3]));
            labelCapture6.Text = string.Format("Capture 6 : {0}", ((stream[4] << 24) | (stream[5] << 16) | (stream[6] << 8) | stream[7]));

            stream[0] = 0x36;
            stream[1] = 0x07;
            writeData(stream, 2);
            Array.Copy(readData(8), 0, stream, 0, 8);
            labelCounter7.Text = string.Format("Counter 7 : {0}", ((stream[0] << 24) | (stream[1] << 16) | (stream[2] << 8) | stream[3]));
            labelCapture7.Text = string.Format("Capture 7 : {0}", ((stream[4] << 24) | (stream[5] << 16) | (stream[6] << 8) | stream[7]));

            stream[0] = 0x36;
            stream[1] = 0x08;
            writeData(stream, 2);
            Array.Copy(readData(8), 0, stream, 0, 8);
            labelCounter8.Text = string.Format("Counter 8 : {0}", ((stream[0] << 24) | (stream[1] << 16) | (stream[2] << 8) | stream[3]));
            labelCapture8.Text = string.Format("Capture 8 : {0}", ((stream[4] << 24) | (stream[5] << 16) | (stream[6] << 8) | stream[7]));
        }

        private byte[] readData(int num)
        {
            byte[] stream = new byte[16];
            NetworkStream serverStream = clientSocket.GetStream();
            try
            {

                serverStream.Read(stream, 0, num);
            }
            catch (Exception e)
            {
                timer1.Stop();
                MessageBox.Show("Read time out, make sure that dS1242 is in binary mode.");
                System.Windows.Forms.Application.Exit();
            }

            return stream;
        }

        private void writeData(byte[] data, int num)
        {
            NetworkStream serverStream = clientSocket.GetStream();
            try
            {

                serverStream.Write(data, 0, num);
            }
            catch (Exception e)
            {
                timer1.Stop();
                MessageBox.Show("Write time out");
                System.Windows.Forms.Application.Exit();
            }
        }

        private void button_Click(object sender, EventArgs e)
        {
            byte[] stream = new byte[16];
            for (int x = 0; x < 16; x++) stream[x] = 0;

            Button button = (Button)sender;
            string buttonId = button.Name;  //name I.E button1
            byte button_number = Convert.ToByte(buttonId.Substring(6)); //number of button I.E 12

            stream[0] = 0x31;
            stream[1] = (byte)(button_number);
            if (button.BackColor == Color.MistyRose) stream[2] = 0;
            else stream[2] = 1;

            writeData(stream, 7);
            Array.Copy(readData(2), 0, stream, 0, 2);
        }

        private void IO_Click(object sender, EventArgs e)
        {
            byte[] stream = new byte[16];

            RadioButton button = (RadioButton)sender;
            string buttonId = button.Name;  //name I.E button1
            byte button_number = Convert.ToByte(buttonId.Substring(2)); //number of button I.E 12

            stream[0] = 0x32;
            stream[1] = (byte)(button_number);
            if (button.Checked == true) stream[2] = 0;
            else stream[2] = 1;

            writeData(stream, 3);
            Array.Copy(readData(2), 0, stream, 0, 2);
        }

        public void ReceiveCallback(IAsyncResult ar)
        {
            UdpState MyUDP = (UdpState)ar.AsyncState;
            byte[] data;
            int line_start = 0;
            int line_end;
            string hostname = null;
            string ipaddress = "";
            string port = "";
            int module_id = 0;

            // Obtain the UDP message body and convert it to a string, with remote IP address attached as well
            data = (MyUDP.UDPClient.EndReceive(ar, ref MyUDP.EP));

            if (System.Text.Encoding.UTF8.GetString(data) != "Discovery: Who is out there?")
            {
                do
                {
                    line_end = Array.IndexOf<byte>(data, 0x0a, line_start);
                    switch (data[line_start])
                    {
                        case 4: hostname = System.Text.Encoding.UTF8.GetString(data, line_start + 1, line_end - line_start);
                            hostname = hostname.TrimEnd();
                            break;
                        case 5: ipaddress = data[line_start + 1].ToString() + '.' + data[line_start + 2].ToString() + '.' + data[line_start + 3].ToString() + '.' + data[line_start + 4].ToString();
                            break;
                        case 64: module_id = data[line_start + 1];
                            break;
                        case 65: port = ((data[line_start + 1] << 8) + data[line_start + 2]).ToString();
                            break;
                        default:  
                            break;
                    }
                    line_start = line_end + 1;
                }
                while (line_start < data.Length);
                if ((module_id == DS1242_MODULEID) && (hostname != null)) comboBox_IP.BeginInvoke(new MethodInvoker(delegate() { comboBox_IP.Items.Add(ipaddress +":"+ port + " - " + hostname); }));
            }
            // Configure the UdpClient class to accept more messages, if they arrive
            MyUDP.UDPClient.BeginReceive(ReceiveCallback, MyUDP);
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            byte[] stream = new byte[16]; 

            if (clientSocket.Connected == true)
            {
                timer1.Enabled = false;
                clientSocket.Close();
                clientSocket = new TcpClient();
            }
            if (comboBox_IP.Text == "Custom IP")
            {
                Form2 secondForm = new Form2();
                secondForm.ShowDialog();
                if (GlobalClass.ipaddress != "0.0.0.0")
                {
                    clientSocket.Connect(GlobalClass.ipaddress,GlobalClass.port);
                }
            }
            else
            {
                GlobalClass.ipaddress = comboBox_IP.Text.Substring(0, comboBox_IP.Text.IndexOf(':'));
                GlobalClass.port = Convert.ToInt16(comboBox_IP.Text.Substring(comboBox_IP.Text.IndexOf(':') + 1, comboBox_IP.Text.IndexOf(' ') - comboBox_IP.Text.IndexOf(':')));
                clientSocket.Connect(GlobalClass.ipaddress, GlobalClass.port);
            }
            if (clientSocket.Connected == true)
            {
                clientSocket.ReceiveTimeout = 500;
                timer1.Enabled = true;
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }
    }
}
