/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package ds1242test;

import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.security.NoSuchAlgorithmException;
import java.util.ArrayList;
import javax.crypto.Cipher;
import javax.swing.JOptionPane;
import javax.swing.Timer;

/**
 *
 * @author James Henderson
 */
public class DS1242ui extends javax.swing.JFrame implements NotificationInterface{

    private NetworkUDPScan n_manager;
    private DS1242Connection module_connection;
    private String ip_string;
    private Timer timer1;
    private byte[] states;
    
    Color on;
    Color off;
    
    /**
     * Creates new form DS1242ui
     */
    public DS1242ui() {
        initComponents();
        n_manager = new NetworkUDPScan();
        buttonRelay1.addActionListener(button_action);          // Register actions for buttons
        buttonRelay2.addActionListener(button_action);
        checkBoxIO1.addActionListener(checkbox_action);
        checkBoxIO2.addActionListener(checkbox_action);
        checkBoxIO3.addActionListener(checkbox_action);
        checkBoxIO4.addActionListener(checkbox_action);

        try {
            long len = Cipher.getMaxAllowedKeyLength("AES/CBC/PKCS5Padding");
            if (len < 256)
            {
                JOptionPane.showMessageDialog(this, "Java unlimited cryptography policy is not installed, can not send encrypted messages to module. Please see readme file that ships with this software for details");
                System.exit(0);
            }
        } catch (NoSuchAlgorithmException ex) {
            
        }
        
        on = new Color(226, 172, 163);
        off = new Color(163, 187, 226);
        
        
    }
    
    ActionListener button_action = new ActionListener() {                        // This is the action listener that will grab the button clicks
        @Override
        public void actionPerformed(ActionEvent e) {
            if (module_connection != null) {
                byte relay = 0;
                if (e.getSource() == buttonRelay1) {
                    relay = 1;
                } else if (e.getSource() == buttonRelay2) {
                    relay = 2;
                } 
                if (module_connection.connected == true) {
                    byte[] state = module_connection.getRelayStates(relay);     // Get the state of the individual realy
                    if ((state[0] & (byte) 0x01) == 1) {                        // Then set it to the opposite
                        module_connection.setRelay(relay, (byte) 0);
                    } else {
                        module_connection.setRelay(relay, (byte) 1);
                    }
                }
            }
        }
    };
    
    ActionListener checkbox_action = new ActionListener() {                     // This is the action listener that will grab the check box clicks
        @Override
        public void actionPerformed(ActionEvent e) {
            if (module_connection != null) {
                byte io = 0;
                if (e.getSource() == checkBoxIO1) {
                    io = 1;
                } else if (e.getSource() == checkBoxIO2) {
                    io = 2;
                } else if (e.getSource() == checkBoxIO3) {
                    io = 3;
                } else if (e.getSource() == checkBoxIO4) {
                    io = 4;
                } 
                if (module_connection.connected == true) {
                    byte[] state = module_connection.getIOs(io);                // Get the state of the individual IO
                    if ((state[0] & (byte) 0x01) == 1) {                        // Then set it to the opposite
                        module_connection.setOutput(io, (byte) 0);
                    } else {
                        module_connection.setOutput(io, (byte) 1);
                    }
                }
            }
        }
    };
    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        modules_combobox = new javax.swing.JComboBox<>();
        buttonRelay1 = new javax.swing.JButton();
        buttonRelay2 = new javax.swing.JButton();
        labelAnalogue1 = new javax.swing.JLabel();
        labelAnalogue2 = new javax.swing.JLabel();
        checkBoxIO1 = new javax.swing.JCheckBox();
        checkBoxIO2 = new javax.swing.JCheckBox();
        checkBoxIO3 = new javax.swing.JCheckBox();
        checkBoxIO4 = new javax.swing.JCheckBox();
        labelCounter1 = new javax.swing.JLabel();
        jSeparator1 = new javax.swing.JSeparator();
        labelCapture1 = new javax.swing.JLabel();
        labelCounter2 = new javax.swing.JLabel();
        labelCounter3 = new javax.swing.JLabel();
        labelCounter4 = new javax.swing.JLabel();
        labelCounter5 = new javax.swing.JLabel();
        labelCounter6 = new javax.swing.JLabel();
        labelCounter7 = new javax.swing.JLabel();
        labelCounter8 = new javax.swing.JLabel();
        labelCapture2 = new javax.swing.JLabel();
        labelCapture3 = new javax.swing.JLabel();
        labelCapture4 = new javax.swing.JLabel();
        labelCapture5 = new javax.swing.JLabel();
        labelCapture6 = new javax.swing.JLabel();
        labelCapture7 = new javax.swing.JLabel();
        labelCapture8 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        modules_combobox.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Select Module" }));
        modules_combobox.addPopupMenuListener(new javax.swing.event.PopupMenuListener() {
            public void popupMenuWillBecomeVisible(javax.swing.event.PopupMenuEvent evt) {
                modules_comboboxPopupMenuWillBecomeVisible(evt);
            }
            public void popupMenuWillBecomeInvisible(javax.swing.event.PopupMenuEvent evt) {
                modules_comboboxPopupMenuWillBecomeInvisible(evt);
            }
            public void popupMenuCanceled(javax.swing.event.PopupMenuEvent evt) {
            }
        });

        buttonRelay1.setText("Relay 1");

        buttonRelay2.setText("Relay 2");

        labelAnalogue1.setText("Analogue 1:");

        labelAnalogue2.setText("Analogue 2:");

        checkBoxIO1.setText("IO1");

        checkBoxIO2.setText("IO2");

        checkBoxIO3.setText("IO3");

        checkBoxIO4.setText("IO4");

        labelCounter1.setText("Counter 1 : ");

        labelCapture1.setText("Capture 1 : ");

        labelCounter2.setText("Counter 2 : ");

        labelCounter3.setText("Counter 3 :");

        labelCounter4.setText("Counter 4 :");

        labelCounter5.setText("Counter 5 : ");

        labelCounter6.setText("counter 6 : ");

        labelCounter7.setText("Counter 7 : ");

        labelCounter8.setText("Counter 8 : ");

        labelCapture2.setText("Capture 2 :");

        labelCapture3.setText("Capture 3 : ");

        labelCapture4.setText("Capture 4 : ");

        labelCapture5.setText("Capture 5 : ");

        labelCapture6.setText("Capture 6 : ");

        labelCapture7.setText("Capture 7 : ");

        labelCapture8.setText("Capture 8 : ");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jSeparator1)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(modules_combobox, javax.swing.GroupLayout.PREFERRED_SIZE, 233, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(0, 0, Short.MAX_VALUE)))
                        .addContainerGap())
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(buttonRelay1, javax.swing.GroupLayout.PREFERRED_SIZE, 181, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(labelAnalogue1, javax.swing.GroupLayout.PREFERRED_SIZE, 103, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(buttonRelay2, javax.swing.GroupLayout.PREFERRED_SIZE, 181, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(labelAnalogue2, javax.swing.GroupLayout.PREFERRED_SIZE, 103, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(checkBoxIO1)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(checkBoxIO2)
                                .addGap(18, 18, 18)
                                .addComponent(checkBoxIO3)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(checkBoxIO4))
                            .addGroup(layout.createSequentialGroup()
                                .addGap(6, 6, 6)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addComponent(labelCounter8, javax.swing.GroupLayout.DEFAULT_SIZE, 120, Short.MAX_VALUE)
                                    .addComponent(labelCounter7, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(labelCounter6, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(labelCounter5, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(labelCounter4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(labelCounter3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(labelCounter2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(labelCounter1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                                .addGap(18, 18, 18)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addComponent(labelCapture1, javax.swing.GroupLayout.DEFAULT_SIZE, 130, Short.MAX_VALUE)
                                    .addComponent(labelCapture2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(labelCapture8, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(labelCapture7, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(labelCapture6, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(labelCapture5, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(labelCapture4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(labelCapture3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))))
                        .addGap(0, 0, Short.MAX_VALUE))))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(modules_combobox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(buttonRelay1)
                    .addComponent(labelAnalogue1, javax.swing.GroupLayout.PREFERRED_SIZE, 26, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(buttonRelay2)
                    .addComponent(labelAnalogue2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(checkBoxIO1)
                    .addComponent(checkBoxIO2)
                    .addComponent(checkBoxIO3)
                    .addComponent(checkBoxIO4))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labelCounter1)
                    .addComponent(labelCapture1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labelCounter2)
                    .addComponent(labelCapture2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labelCounter3)
                    .addComponent(labelCapture3))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labelCounter4)
                    .addComponent(labelCapture4))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labelCounter5)
                    .addComponent(labelCapture5))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labelCounter6)
                    .addComponent(labelCapture6))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labelCounter7)
                    .addComponent(labelCapture7))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labelCounter8)
                    .addComponent(labelCapture8))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void modules_comboboxPopupMenuWillBecomeInvisible(javax.swing.event.PopupMenuEvent evt) {//GEN-FIRST:event_modules_comboboxPopupMenuWillBecomeInvisible
        if (modules_combobox.getSelectedIndex() == 0) {
            return; // return because item 0 is never a module, its the text "Select Module"
        }
        ip_string = modules_combobox.getSelectedItem().toString().substring(modules_combobox.getSelectedItem().toString().lastIndexOf(" ") + 1); // This will contain the ip address and port seperated by a colon

        // Ip address is first part of string before : port is second part of string
        module_connection = new DS1242Connection(ip_string.substring(0, ip_string.lastIndexOf(":")),
                Integer.valueOf(ip_string.substring(ip_string.lastIndexOf(":") + 1)));

        if (module_connection.connected == true) {
            module_connection.registerForNotifications(this);                   // Register to receive notifications
            module_connection.getStatus();
            timer1 = new Timer(300, (ActionEvent e) -> {
                byte[] states1 = module_connection.getRelayStates((byte)0x01); // Set the colours of the relay buttons
                if ((states1[4] & (byte) 0x01) > 0) {
                    buttonRelay1.setBackground(on);
                } else {
                    buttonRelay1.setBackground(off);
                }
                if ((states1[4] & (byte) 0x02) != 0) {
                    buttonRelay2.setBackground(on);
                } else {
                    buttonRelay2.setBackground(off);
                }
                int[] analogue = module_connection.getAnalogueInputs();                 // Get the values of the Analogue IO ports
                labelAnalogue1.setText("Analogue 1 : " + String.valueOf(analogue[0]));
                labelAnalogue2.setText("Analogue 2 : " + String.valueOf(analogue[1]));
                byte[] io_states = module_connection.getIOs((byte)0x01);                // Get the values of digital IO ports
                if ((io_states[1] & (byte) 0x01) > 0) {
                    checkBoxIO1.setSelected(true);
                } else {
                    checkBoxIO1.setSelected(false);
                }
                if ((io_states[1] & (byte) 0x02) != 0) {
                    checkBoxIO2.setSelected(true);
                } else {
                    checkBoxIO2.setSelected(false);
                }
                if ((io_states[1] & (byte) 0x04) != 0) {
                    checkBoxIO3.setSelected(true);
                } else {
                    checkBoxIO3.setSelected(false);
                }
                if ((io_states[1] & (byte) 0x08) != 0) {
                    checkBoxIO4.setSelected(true);
                } else {
                    checkBoxIO4.setSelected(false);
                }
                int[] counter = new int[2];
                counter = module_connection.getCounterTimer((byte)0x01);                    // Get the Timer/ Counter values
                labelCounter1.setText("Counter 1 : " + String.valueOf(counter[0]));         // Display them
                labelCapture1.setText("Capture 1 : " + String.valueOf(counter[1]));
                counter = module_connection.getCounterTimer((byte)0x02);
                labelCounter2.setText("Counter 2 : " + String.valueOf(counter[0]));
                labelCapture2.setText("Capture 2 : " + String.valueOf(counter[1]));
                counter = module_connection.getCounterTimer((byte)0x03);
                labelCounter3.setText("Counter 3 : " + String.valueOf(counter[0]));
                labelCapture3.setText("Capture 3 : " + String.valueOf(counter[1]));
                counter = module_connection.getCounterTimer((byte)0x04);
                labelCounter4.setText("Counter 4 : " + String.valueOf(counter[0]));
                labelCapture4.setText("Capture 4 : " + String.valueOf(counter[1]));
                counter = module_connection.getCounterTimer((byte)0x05);
                labelCounter5.setText("Counter 5 : " + String.valueOf(counter[0]));
                labelCapture5.setText("Capture 5 : " + String.valueOf(counter[1]));
                counter = module_connection.getCounterTimer((byte)0x06);
                labelCounter6.setText("Counter 6 : " + String.valueOf(counter[0]));
                labelCapture6.setText("Capture 6 : " + String.valueOf(counter[1]));
                counter = module_connection.getCounterTimer((byte)0x07);
                labelCounter7.setText("Counter 7 : " + String.valueOf(counter[0]));
                labelCapture7.setText("Capture 7 : " + String.valueOf(counter[1]));
                counter = module_connection.getCounterTimer((byte)0x08);
                labelCounter8.setText("Counter 8 : " + String.valueOf(counter[0]));
                labelCapture8.setText("Capture 8 : " + String.valueOf(counter[1]));
            } // Setup timer
            );
            timer1.start();
        }
    }//GEN-LAST:event_modules_comboboxPopupMenuWillBecomeInvisible

    private void modules_comboboxPopupMenuWillBecomeVisible(javax.swing.event.PopupMenuEvent evt) {//GEN-FIRST:event_modules_comboboxPopupMenuWillBecomeVisible
        // Display the modules received from the UDP scan in the combo box
        modules_combobox.removeAllItems();
        modules_combobox.addItem("Select Module");
        ArrayList<String> mods = n_manager.getModuleList();
        mods.forEach((str) -> {
            modules_combobox.addItem(str);
        });
    }//GEN-LAST:event_modules_comboboxPopupMenuWillBecomeVisible

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(DS1242ui.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(DS1242ui.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(DS1242ui.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(DS1242ui.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new DS1242ui().setVisible(true);
            }
        });
    }

    @Override
    public void networkError(String error) {            // Implemented form NotificationInterface.java
        if (timer1 != null) {
            timer1.stop();
        }
        module_connection.close();
        javax.swing.SwingUtilities.invokeLater(new Runnable() {
            @Override
            public void run() {
                JOptionPane.showOptionDialog(null, error, "Test", JOptionPane.DEFAULT_OPTION,
                JOptionPane.INFORMATION_MESSAGE, null, null, null);
                System.exit(0);
            }
        }); 
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton buttonRelay1;
    private javax.swing.JButton buttonRelay2;
    private javax.swing.JCheckBox checkBoxIO1;
    private javax.swing.JCheckBox checkBoxIO2;
    private javax.swing.JCheckBox checkBoxIO3;
    private javax.swing.JCheckBox checkBoxIO4;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JLabel labelAnalogue1;
    private javax.swing.JLabel labelAnalogue2;
    private javax.swing.JLabel labelCapture1;
    private javax.swing.JLabel labelCapture2;
    private javax.swing.JLabel labelCapture3;
    private javax.swing.JLabel labelCapture4;
    private javax.swing.JLabel labelCapture5;
    private javax.swing.JLabel labelCapture6;
    private javax.swing.JLabel labelCapture7;
    private javax.swing.JLabel labelCapture8;
    private javax.swing.JLabel labelCounter1;
    private javax.swing.JLabel labelCounter2;
    private javax.swing.JLabel labelCounter3;
    private javax.swing.JLabel labelCounter4;
    private javax.swing.JLabel labelCounter5;
    private javax.swing.JLabel labelCounter6;
    private javax.swing.JLabel labelCounter7;
    private javax.swing.JLabel labelCounter8;
    private javax.swing.JComboBox<String> modules_combobox;
    // End of variables declaration//GEN-END:variables
}
