/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package DS2824Test;

import java.net.*;
import java.io.*;
import java.util.concurrent.locks.*;
import java.util.ArrayList;

/**
 *
 * @author devantech
 */
public class NetworkUDPScan {

    String udp_string = new String("Discovery: Who is out there?\0\n");
    private Thread receive_thread = null;
    private DatagramSocket socket;
    private DatagramPacket packet;
    String received = " ";
    ReentrantLock lock = new ReentrantLock();
    private ArrayList<String> modules = new ArrayList<String>();

    // Constructor
    public NetworkUDPScan() {
        udpAction();            // Do the udp scan
    }

    private void udpAction() {
        try {
            receive_thread = new Thread() {
                public void run() {
                    receiveUDPPacket();
                }
            };

            socket = new DatagramSocket(30303);
            socket.setBroadcast(true);
            InetAddress address = InetAddress.getByName("255.255.255.255");
            packet = new DatagramPacket(udp_string.getBytes(),
                    udp_string.length(), address, 30303);

            socket.send(packet);
            receive_thread.start();
        } catch (IOException e) {
            close_action();
        }
    }

    private void receiveUDPPacket() {
        try {
            byte[] buf = new byte[1500 - 28];
            for (int i = 0; i < buf.length; i++) {
                buf[i] = ' ';
            }
            packet = new DatagramPacket(buf, buf.length);

            //ignore first packet which is a loopback one
            socket.receive(packet);

            received = new String(packet.getData());
            for (;;) {
                for (int i = 0; i < buf.length; i++) {
                    buf[i] = ' ';
                }
                packet = new DatagramPacket(buf, buf.length);

                try {
                    socket.receive(packet);
                } catch (SocketTimeoutException e) {

                }

                if (new String(packet.getData()).trim().length() == 0) {
                    continue;
                }
                if (packet.getLength() < 35) {
                    continue;
                }

                lock.lock();
                try {
                    addDiscoveryEntry(packet);
                    received = " ";
                } finally {
                    lock.unlock();
                }
            }
        } catch (IOException e) {
            close_action();
        }
    }

    public void close_action() {
        if (socket != null) {
            if (socket.isConnected() == true) {
                socket.close();
            }
        }
        if (receive_thread != null) {
            if (receive_thread.isAlive() == true) {
                receive_thread = null;
            }
        }

    }

    private void addDiscoveryEntry(DatagramPacket receivedPacket) {
        byte[] packet_buffer = receivedPacket.getData();
        int packet_length = receivedPacket.getLength();
        int data_count = 0;
        String mac_address = "MAC-Address - ";
        String host_name = "";
        String ip_addr = " - ";
        String module_id = " ";
        String port_number = ":";

        byte[] temp = new byte[6];;
        int index = 0;

        String byteToStr = new String(temp);
        for (data_count = 0; data_count < packet_length;) {
            switch (packet_buffer[data_count]) {
                case 0x01:
                    return;
                case 0x02: // MAC address
                    data_count++;
                    for (index = 0; index < 6; index++) {
                        temp[index] = packet_buffer[data_count++];
                    }

                    if (temp.length == 0) {
                        break;
                    }
                    // MAC address string construction
                    StringBuilder sb = new StringBuilder(22);
                    for (byte b : temp) {
                        if (sb.length() > 0) {
                            sb.append(':');
                        }
                        sb.append(String.format("%02x", b));
                    }
                    mac_address = mac_address.concat(sb.toString());
                    break;
                case 0x03: // MAC Type
                    data_count++;
                    temp = new byte[16];
                    index = 0;
                    while ((packet_buffer[data_count] != 0x0d) && (packet_buffer[data_count + 1] != 0x0a)) {
                        temp[index++] = packet_buffer[data_count++];
                    }
                    break;
                case 0x04: // Host Name
                    data_count++;
                    temp = new byte[16];
                    index = 0;
                    while ((packet_buffer[data_count] != 0x0d) && (packet_buffer[data_count + 1] != 0x0a)) {
                        temp[index++] = packet_buffer[data_count++];
                    }
                    byteToStr = new String(temp);
                    byteToStr = byteToStr.substring(0, byteToStr.indexOf(" "));

                    host_name = host_name.concat(byteToStr);
                    break;
                case 0x05: // IPv4 Address
                    temp = new byte[4];
                    data_count++;
                    index = 0;
                    while (index < 4) {
                        temp[index++] = packet_buffer[data_count++];
                    }

                    if (temp.length == 0) {
                        break;
                    }
                    sb = new StringBuilder(22);
                    for (byte b : temp) {
                        if (sb.length() > 0) {
                            sb.append('.');
                        }
                        sb.append(String.format("%d", (short) (b & 0xFF)));
                    }
                    ip_addr = ip_addr.concat(sb.toString());
                    break;
                case 0x06: // IPv6U address
                    break;
                case 0x07: // IPv6M Address
                    break;
                case 0x08: // IPv6Deafult Router address
                    break;
                case 0x09: // IPv6Deafult Gateway address
                    break;
                case 0x40:
                    data_count++;
                    temp = new byte[16];
                    index = 0;
                    while ((packet_buffer[data_count] != 0x0d) && (packet_buffer[data_count + 1] != 0x0a)) {
                        temp[index++] = packet_buffer[data_count++];
                    }

                    switch (temp[0]) {
                        case 30:
                            module_id = module_id.concat("dS3484 ");
                            break;
                        case 31:
                            module_id = module_id.concat("dS1242 ");
                            break;
                        case 34:
                            module_id = module_id.concat("dS2824 ");
                            module_id = module_id.concat("(" + Byte.toString(temp[0]) + ")");
                            break;
                        case 35:
                            module_id = module_id.concat("dS378 ");
                            break;
                    }
                    break;
                case 0x41:

                    data_count++;
                    temp = new byte[16];
                    index = 0;
                    while ((packet_buffer[data_count] != 0x0d) && (packet_buffer[data_count + 1] != 0x0a)) {
                        temp[index++] = packet_buffer[data_count++];
                    }

                    int port = ((temp[0] & 0xff) << 8) | (temp[1] & 0xff);

                    port_number = port_number.concat(String.valueOf(port));
                    modules.add(host_name + ip_addr + port_number);
                    break;
                default:
                    return;
            }
            if (packet_buffer[data_count] == 0x0d) {
                data_count++;
            }
            if (packet_buffer[data_count] == 0x0a) {
                data_count++;
            }
        }
    }

    public ArrayList<String> getModuleList() {                                  // Return the array list that has all the found modules in it
        return modules;
    }

}
