/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package dscriptmodbus;

import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 *
 * @author James Henderson
 */
public class ConnectionUI extends javax.swing.JFrame {

    private final NetworkUDPScan scanner;
    private final ActionListener callback;

    /**
     * Creates new form ConnectionUI
     */
    public ConnectionUI(ActionListener l) {
        initComponents();
        this.setTitle("dScript modbus example");
        scanner = new NetworkUDPScan();
        callback = l;
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        module_list = new javax.swing.JComboBox<>();
        module_uid = new javax.swing.JTextField();
        uid_label = new javax.swing.JLabel();
        connect_button = new javax.swing.JButton();
        downstream_uid_label = new javax.swing.JLabel();
        downstream_uid = new javax.swing.JTextField();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        module_list.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Select Module" }));
        module_list.addPopupMenuListener(new javax.swing.event.PopupMenuListener() {
            public void popupMenuWillBecomeVisible(javax.swing.event.PopupMenuEvent evt) {
                module_listPopupMenuWillBecomeVisible(evt);
            }
            public void popupMenuWillBecomeInvisible(javax.swing.event.PopupMenuEvent evt) {
            }
            public void popupMenuCanceled(javax.swing.event.PopupMenuEvent evt) {
            }
        });

        module_uid.setText("1");

        uid_label.setText("dScript module UID");

        connect_button.setText("Connect");
        connect_button.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                connect_buttonActionPerformed(evt);
            }
        });

        downstream_uid_label.setText("Downstream UID");

        downstream_uid.setText("2");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(module_list, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(uid_label)
                            .addComponent(downstream_uid_label))
                        .addGap(18, 18, 18)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addComponent(downstream_uid, javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(module_uid, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 67, Short.MAX_VALUE))
                        .addGap(0, 0, Short.MAX_VALUE)))
                .addContainerGap())
            .addGroup(layout.createSequentialGroup()
                .addGap(106, 106, 106)
                .addComponent(connect_button, javax.swing.GroupLayout.PREFERRED_SIZE, 106, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(107, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(module_list, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(module_uid, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(uid_label))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(downstream_uid_label)
                    .addComponent(downstream_uid, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addComponent(connect_button)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void module_listPopupMenuWillBecomeVisible(javax.swing.event.PopupMenuEvent evt) {//GEN-FIRST:event_module_listPopupMenuWillBecomeVisible
        module_list.removeAllItems();
        module_list.addItem("Select Module");
        ArrayList<String> mods = scanner.getModuleList();
        mods.forEach((str) -> {
            module_list.addItem(str);
        });
    }//GEN-LAST:event_module_listPopupMenuWillBecomeVisible

    private void connect_buttonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_connect_buttonActionPerformed

        if (module_list.getSelectedIndex() == 0) {
            return; // Do nothing in this case, we can not connect to the "Select Module" option in module_list
        }

        int uid = Integer.parseInt(module_uid.getText());
        int duid = Integer.parseInt(downstream_uid.getText());
        /*  get the data we need from the string in the combo box drop down.
            The text of the selected item will be in the format:
            
            hostname(module id) ipaddress:port
            
            We wil need to seperate these bits of information out
        */
        
        String ip_string = module_list.getSelectedItem().toString().substring(module_list.getSelectedItem().toString().lastIndexOf(" ") + 1).split(":")[0];
        int port = Integer.parseInt(module_list.getSelectedItem().toString().substring(module_list.getSelectedItem().toString().lastIndexOf(" ") + 1).split(":")[1]);
        
        // Get the module id from the checkbox using regex which grabs the text between the brackets
        Pattern p = Pattern.compile("(?<=\\()([^\\]]+)(?=\\))");
        Matcher m = p.matcher(module_list.getSelectedItem().toString());
        m.find();
        String mid = m.group();

        // Post an event back that has the module details in it
        ConnectionFormSubmitAction connect_event = new ConnectionFormSubmitAction(this, 0, "connect");
        connect_event.setIP(ip_string);
        connect_event.setDownstreamUID(duid);
        connect_event.setModuleID(Integer.parseInt(mid));
        connect_event.setPort(port);
        connect_event.setUID(uid);
        callback.actionPerformed(connect_event);
    }//GEN-LAST:event_connect_buttonActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton connect_button;
    private javax.swing.JTextField downstream_uid;
    private javax.swing.JLabel downstream_uid_label;
    private javax.swing.JComboBox<String> module_list;
    private javax.swing.JTextField module_uid;
    private javax.swing.JLabel uid_label;
    // End of variables declaration//GEN-END:variables
}
