/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package dscriptmodbus;

import java.awt.Color;
import java.awt.event.ActionListener;

/**
 * This is the base class that the relay buttons and then io check boxes extend.
 * It holds a static connection to the module and a static error call back action listener.
 * As these fields are static all objects that extend this class will have access to them
 * 
 * @author James Henderson
 */
public class ControlAction {
    
    protected static ModbusTCPConnection connection;
    protected static ActionListener error_action;
    protected final Color off = new Color(163, 187, 226);
    
    public void setConnectionForCheckBoxes(ModbusTCPConnection c) {
        // Set the connection to be used for all of the relay buttons
        // As the connection is static
        connection = c;
    }
    
    public void setErrorCallback(ActionListener acb) {
        error_action = acb;
    }
    
}
