/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package dscriptmodbus;

import java.awt.event.ActionEvent;
import java.io.IOException;
import javax.swing.JOptionPane;

/**
 *
 * @author James Henderson
 */
public class DScriptModbus {

    private ConnectionUI cui;
    private ModbusTCPConnection connection;
    private ControlUI control_ui;
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        
        new DScriptModbus();

    }

    public DScriptModbus() {
        // Create our connection ui with a callback for when a connection is to be opened
        cui = new ConnectionUI((ActionEvent e) -> {

            ConnectionFormSubmitAction evt = (ConnectionFormSubmitAction) e;

            String ip = evt.getIP();
            int port = evt.getPort();
            int mid = evt.getModuleId();
            int uid = evt.getUID();
            int duid = evt.getDownstreamUID();
            
            // Try to connect to the module
            try {
                connection = new ModbusTCPConnection(ip, port, uid, duid);
            } catch (IOException ex) {
                JOptionPane.showMessageDialog(cui, "Could not connect to module.", "Warning", JOptionPane.WARNING_MESSAGE);
                return;
            }
            
            // Display the UI for the appropriate module
            switch (mid) {
                case 30:
                    control_ui = new DS3484UI(connection);
                    cui.setVisible(false);
                    control_ui.setVisible(true);
                    break;
                case 31:
                    control_ui= new DS1242UI(connection);
                    cui.setVisible(false);
                    control_ui.setVisible(true);
                    break;
                case 34:
                    control_ui = new DS2824UI(connection);
                    cui.setVisible(false);
                    control_ui.setVisible(true);
                    break;
                case 35:
                    control_ui = new DS378UI(connection);
                    cui.setVisible(false);
                    control_ui.setVisible(true);
                    break;
                case 36:
                    control_ui = new TCP184UI(connection);
                    cui.setVisible(false);
                    control_ui.setVisible(true);
                    break;
            }
        });

        cui.setVisible(true);

    }

}
